# coding: utf-8

"""
    URL Shortener API

    This API is responsible of authetication and the creation, modification and deletion of uris and hooks.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class HookActionHTTP(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'endpoint': 'str',
        'verb': 'str',
        'params': 'str',
        'body': 'object'
    }

    attribute_map = {
        'endpoint': 'endpoint',
        'verb': 'verb',
        'params': 'params',
        'body': 'body'
    }

    def __init__(self, endpoint=None, verb=None, params=None, body=None):  # noqa: E501
        """HookActionHTTP - a model defined in Swagger"""  # noqa: E501
        self._endpoint = None
        self._verb = None
        self._params = None
        self._body = None
        self.discriminator = None
        if endpoint is not None:
            self.endpoint = endpoint
        if verb is not None:
            self.verb = verb
        if params is not None:
            self.params = params
        if body is not None:
            self.body = body

    @property
    def endpoint(self):
        """Gets the endpoint of this HookActionHTTP.  # noqa: E501


        :return: The endpoint of this HookActionHTTP.  # noqa: E501
        :rtype: str
        """
        return self._endpoint

    @endpoint.setter
    def endpoint(self, endpoint):
        """Sets the endpoint of this HookActionHTTP.


        :param endpoint: The endpoint of this HookActionHTTP.  # noqa: E501
        :type: str
        """

        self._endpoint = endpoint

    @property
    def verb(self):
        """Gets the verb of this HookActionHTTP.  # noqa: E501


        :return: The verb of this HookActionHTTP.  # noqa: E501
        :rtype: str
        """
        return self._verb

    @verb.setter
    def verb(self, verb):
        """Sets the verb of this HookActionHTTP.


        :param verb: The verb of this HookActionHTTP.  # noqa: E501
        :type: str
        """

        self._verb = verb

    @property
    def params(self):
        """Gets the params of this HookActionHTTP.  # noqa: E501


        :return: The params of this HookActionHTTP.  # noqa: E501
        :rtype: str
        """
        return self._params

    @params.setter
    def params(self, params):
        """Sets the params of this HookActionHTTP.


        :param params: The params of this HookActionHTTP.  # noqa: E501
        :type: str
        """

        self._params = params

    @property
    def body(self):
        """Gets the body of this HookActionHTTP.  # noqa: E501


        :return: The body of this HookActionHTTP.  # noqa: E501
        :rtype: object
        """
        return self._body

    @body.setter
    def body(self, body):
        """Sets the body of this HookActionHTTP.


        :param body: The body of this HookActionHTTP.  # noqa: E501
        :type: object
        """

        self._body = body

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(HookActionHTTP, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HookActionHTTP):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
